program kvadrat !2d
  implicit none
  real(8), allocatable :: r(:,:) ! r = krajevni vektor ima dva indeksa. prvi je število delcev, drugi pa št koordinat (če smo v 1D bo to 1, v 2D bo to 2 ...)
  real(8) :: x(2), ii(2)
  real(8) :: rho, l, dx, dy !rabimo gostoto, l in razdaljo rabimo zračunat
  integer :: i, j, N, Nposkus !stejemo po parih + rabimo st delcev
  logical :: prekritje !če true = dva delca se prekrivata

  write(*,*) 'Koliko delcev? N = ' !program nas bo vprašal, koliko delcev hočemo
  read(*,*) N !preberemo
  write(*,*) 'Gostota? rho = ' !zanima nas gostota
  read(*,*) rho !jo preberemo

  !zdaj lahko zračunamo dolžino škatle. Za 2D je to koren od N/rho

  l = sqrt(N/rho)
  ii = 1
  write(*,*) 'rob kvadrata = ', l !na zaslon izpišemo dolžino škatle

  allocate(r(N,2)) !!N delcev mamo pa v dveh dimenzijah smo. x rabimo za naključno koordinato

  call random_number(x) ! x ima dve komponenti in ko pokličem call random number bo dobil x dve naključni komponenti, obe imata lahko vrednost med 0 in 1
  r(1,:) = x*l - 0.5*l !vse komponente se pomnožijo z l-jem in odštelemo l/2 ... in to so kar koordinate prvega vektorja

  do i=2, N !od 2 naprej, ker prvi delc že mamo

     prekritje = .true.
     Nposkus = 1
     
     !tok casa delec vstavljamo notri, dokler se z nobenim ne prekirva
     do while (prekritje)
        call random_number(x)
        r(i,:) = l*(x - 0.5*ii) !i-ti vektor

        prekritje = .false.
        
        do j=1,i-1
           dx = abs(r(i,1)-r(j,1)) !razlika v x smeri
           if (dx>0.5*l) dx = abs(dx-l) ! periodični robni pogoj X

           dy = abs(r(i,2)-r(j,2))
           if (dy>0.5*l) dy = abs(dy-l) ! periodični robni pogoj X

           ! lahko primerjamo kvadrat razdalje (dosti hitreje), ker je 1*1 = 1 !
           if (dx**2 + dy**2 < 1) prekritje = .true. !če je ta razdalja manjša od l, se delca prekrivata
        enddo
        Nposkus = Nposkus + 1
        if (real(Nposkus) > 1e7) stop 'preveč poskusov ==> prevelika gostota'
     enddo
     !write(*,*) i
  enddo

  open(100, file='delci.dat')
  do i=1,N
     write(100,*) r(i,:) !obe koordinate bo izpisal v isti vrstici
  enddo
  close(100)

  !risanje škatle na grafu
  open (101,file='box.dat')
  write(101,*) -l/2,-l/2
  write(101,*) -l/2,l/2
  write(101,*) l/2,l/2
  write(101,*) l/2,-l/2
  write(101,*) -l/2,-l/2

end program kvadrat
        
