program random_walk
  implicit none
  integer, parameter :: maxsim = 1000
  real(8) :: r(2,maxsim) ! r(1,:) = x-coordinates; r(2,:) = y-coordinates
  real(8) :: a, tpi, aver_dist, dist(maxsim)
  integer :: i, N !števec, ki šteje koliko korakov
  integer :: p, isim

  tpi = 2d0 * 4d0*atan(1d0)
  
  write(*,*) 'Koliko korakov? N='
  read(*,*) N
  write(*,*) 'Koliko ponovitev simulacije? p='
  read(*,*) p
  if ( p > maxsim ) stop 'p is too large'

  open(100, file='koordinata-moja.dat') ! zapis koordinat
  open(200, file='razdalja-moja.dat') ! zaporedni korak + oddaljenost od izhodisca
  open(300, file='povprecje.dat') ! zaporedni korak + povprečna oddaljenost od izhodišča od vseh ponovitev

  !začetni pogoji
  r = 0d0
  dist = 0d0
  aver_dist = 0d0

  ! this is equivalent to: write(100,*) ((r(i,isim), i=1,2), isim=1,p)
  write(100,*) (r(:,isim), isim=1,p)  
  write(200,*) 0, (dist(isim), isim=1,p)
  write(300,*) 0, 0

  do i=1,N
     do isim=1,p
        call random_number(a)
        r(1,isim) = r(1,isim) + cos(tpi*a) ! x(isim)
        r(2,isim) = r(2,isim) + sin(tpi*a) ! y(isim)
        dist(isim) = sqrt(r(1,isim)**2 + r(2,isim)**2)
     enddo
     !
     aver_dist = sum(dist,p) / dble(p)        
     !
     write(100,*) (r(:,isim), isim=1,p)
     write(200,*) i, (dist(isim), isim=1,p)
     write(300,*) i, aver_dist
     !
  enddo
 
  close(100)
  close(200)
  close(300)

end program random_walk

  
